package com.hzya.frame.sys.integrationtask.living.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.sys.integrationtask.living.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.web.entity.JsonResultEntity;

/**
 * @description: 集成任务实例详情  service
 * @tableName: integration_task_living_details
 * @entityName: IntegrationTaskLivingDetailsEntity
 * @author: gjh
 * @history: 1.0
 */
public interface IIntegrationTaskLivingDetailsService extends IBaseService<IntegrationTaskLivingDetailsEntity, String> {

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询列表 分页
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity queryPage(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 获取数据 根据id
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity queryEntity(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 批量推送
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity batchPush(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 重新推送
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity repush(JSONObject jsonObject);

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 手工处理
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity manualProcessing(JSONObject jsonObject);


    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 删除
     * @Date 2:18 下午 2023/7/17
     **/
    JsonResultEntity deleteEntity(JSONObject jsonObject);
}
