package com.hzya.frame.sys.integrationtask.living.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.basedao.entity.ConditionType;
import com.hzya.frame.basedao.entity.ConnectType;
import com.hzya.frame.basedao.entity.WhereCriterion;
import com.hzya.frame.basedao.service.impl.BaseDaoUtilImpl;
import com.hzya.frame.sys.integrationtask.living.entity.IntegrationTaskLivingDetailsVo;
import com.hzya.frame.util.PluginUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.hzya.frame.sys.integrationtask.living.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sys.integrationtask.living.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.sys.integrationtask.living.dao.IIntegrationTaskLivingDetailsDao;
import com.hzya.frame.basedao.service.impl.BaseService;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * @description: 集成任务实例详情  service
 * @tableName: integration_task_living_details
 * @entityName: IntegrationTaskLivingDetailsEntity
 * @author: gjh
 * @history: 1.0
 */
@Service(value = "integration_task_living_detailsService")
public class IntegrationTaskLivingDetailsServiceImpl extends BaseService<IntegrationTaskLivingDetailsEntity, String> implements IIntegrationTaskLivingDetailsService {

    protected IIntegrationTaskLivingDetailsDao integrationtasklivingdetailsDao;

    @Autowired
    private BaseDaoUtilImpl baseDaoUtilImpl;

    @Autowired
    public void setIntegrationTaskLivingDetailsDao(IIntegrationTaskLivingDetailsDao dao) {
        this.integrationtasklivingdetailsDao = dao;
        this.dao = dao;
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询列表 分页
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity queryPage(JSONObject object) {
        IntegrationTaskLivingDetailsVo entity = getData("jsonStr", object, IntegrationTaskLivingDetailsVo.class);
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<IntegrationTaskLivingDetailsVo> integrationTaskLivingDetailsEntityList = integrationtasklivingdetailsDao.queryPageLeftTask(entity);
        if (integrationTaskLivingDetailsEntityList != null && integrationTaskLivingDetailsEntityList.size() > 0) {
            for (int i = 0; i < integrationTaskLivingDetailsEntityList.size(); i++) {
                PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(integrationTaskLivingDetailsEntityList.get(i).getPlugin_id());
                if (pluginBaseEntity != null) {
                    integrationTaskLivingDetailsEntityList.get(i).setPlugin_name(pluginBaseEntity.getPluginName());
                }
            }
        }
        PageInfo pageInfo = new PageInfo(integrationTaskLivingDetailsEntityList);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 获取数据 根据id
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity queryEntity(JSONObject object) {
        IntegrationTaskLivingDetailsEntity entity = getData("jsonStr", object, IntegrationTaskLivingDetailsEntity.class);
        //判断分页
        if (entity == null || entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("请先传递请求主键");
        }
        IntegrationTaskLivingDetailsEntity appApi = integrationtasklivingdetailsDao.queryOne(entity);
        return BaseResult.getSuccessMessageEntity("查询数据成功", appApi);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 批量推送
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity batchPush(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        String plugin_id = "com.hzya.frame.plugin.sowow.plugin.sales.SoSalePluginInitializerToB";


        String id = jsonObject.getString("id");
        if (!checkStr(id)) {
            return BaseResult.getFailureMessageEntity("请先选择要推送的数据");
        }
        PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(plugin_id);
        JSONObject send = new JSONObject();
        send.put("type", "detailid");
        send.put("param", id);

        try {
            pluginBaseEntity.executeBusiness(send);
            return BaseResult.getSuccessMessageEntity("批量推送成功");
        } catch (Exception e) {
            return BaseResult.getFailureMessageEntity("批量推送失败");
        }
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 重新推送
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity repush(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        String plugin_id = jsonObject.getString("plugin_id");//"com.hzya.frame.plugin.sowow.plugin.sales.SoSalePluginInitializerToB";
        String id = jsonObject.getString("id");
        if (!checkStr(id)) {
            return BaseResult.getFailureMessageEntity("请先选择要推送的数据");
        }
        PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(plugin_id);
        JSONObject send = new JSONObject();
        send.put("type", "details_error");
        send.put("pluginId", plugin_id);
        send.put("integration_task_living_details_id", id);


        try {
            pluginBaseEntity.executeBusiness(send);
            return BaseResult.getSuccessMessageEntity("重新推送成功");
        } catch (Exception e) {
            return BaseResult.getFailureMessageEntity("重新推送失败");
        }
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 手工处理
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity manualProcessing(JSONObject object) {
        IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = getData("jsonStr", object, IntegrationTaskLivingDetailsEntity.class);
        if (integrationTaskLivingDetailsEntity == null && integrationTaskLivingDetailsEntity.getId() != null && !"".equals(integrationTaskLivingDetailsEntity.getId())) {
            return BaseResult.getFailureMessageEntity("请求参数不存在");
        }
        integrationTaskLivingDetailsEntity.setModify_user_id(StpUtil.getLoginIdAsString());
        integrationTaskLivingDetailsEntity.setModify_time(new Date());
        integrationTaskLivingDetailsEntity.setProcessor(StpUtil.getLoginIdAsString());
        //检查用户名密码是否正确
        List<WhereCriterion> whereList = new ArrayList<>();
        WhereCriterion passwordCondition = new WhereCriterion("", "id", ConditionType.等于.getValue(), StpUtil.getLoginIdAsString(), "", ConnectType.AND);
        whereList.add(passwordCondition);
        HashMap<String, Object> userMap = baseDaoUtilImpl.selectOne("sys_user", whereList);
        integrationTaskLivingDetailsEntity.setProcessor_name(userMap.get("login_code").toString());
        integrationTaskLivingDetailsEntity.setProcessing_time(new Date());
        integrationTaskLivingDetailsEntity.setNew_state("H");
        integrationtasklivingdetailsDao.entity_updatebyid(integrationTaskLivingDetailsEntity);
        return BaseResult.getSuccessMessageEntity("手工处理成功");
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 删除
     * @Date 2:18 下午 2023/7/17
     **/
    @Override
    public JsonResultEntity deleteEntity(JSONObject object) {
        IntegrationTaskLivingDetailsEntity entity = getData("jsonStr", object, IntegrationTaskLivingDetailsEntity.class);
        //判断编码是否重复
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("请先选择数据");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("请先选择数据");
        }
        //删除
        IntegrationTaskLivingDetailsEntity deleteEntity = new IntegrationTaskLivingDetailsEntity();
        deleteEntity.setId(entity.getId());
        deleteEntity.setModify_user_id(StpUtil.getLoginIdAsString());
        deleteEntity.setModify_time(new Date());
        deleteEntity.setSts("Y");
        integrationtasklivingdetailsDao.logicRemove(deleteEntity);
        return BaseResult.getSuccessMessageEntity("删除成功");
    }
}
