package com.hzya.frame.sys.integrationtask.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.sys.integrationtask.entity.IntegrationTaskEntity;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.quartz.JobExecutionContext;

import java.util.Date;
import java.util.List;

/**
 * @description: 集成任务  service
 * @tableName: integration_task
 * @entityName: IntegrationTaskEntity
 * @author: gjh
 * @history: 1.0
 */
public interface IIntegrationTaskService extends IBaseService<IntegrationTaskEntity, String> {

    //集成任务新增
    JsonResultEntity saveIntegrationTask(JSONObject jsonObject) throws  Exception;

    //集成任务修改
    JsonResultEntity updateIntegrationTask(JSONObject jsonObject) throws  Exception;

    //集成任务删除 将sts状态修改为N
    JsonResultEntity updateIntegrationTaskSts(JSONObject jsonObject);


    //查询单个
    JsonResultEntity queryIntegrationTaskById(JSONObject jsonObject);

    //保存日志和实例
    void saveLogAndLiving(JSONObject jsonObjectStr, Date dateStart);

    /***
     * 不同的项目工程内，需要初始化的插件不尽相同，需要按照自身项目组织初始化插件
     * @content:
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date  2023-09-22 15:45
     * @param taskIdList  需要初始化的ID集合
     * @return void
     **/
    void initTaskByIds(List<String> taskIdList);

    void  thirdInterfaceSaveTest(JSONObject jsonObject);
}
